<?php
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
require $path.'/common.php';
$action='show';
if(isset($_REQUEST['action']) &&!empty($_REQUEST['action']))
{
    $action=$_REQUEST['action'];
}
if($action =='cleanrule')
{
    $frule = fopen($path.RULES_FILE,'r+');
    if($frule===FALSE)
    {
        header('HTTP/1.1 500 Internal Server Error');
        echo "can't open rule file\n";
        exit(1);
    }     
    $rulecontent="";
    $rules = array();
    while (($buffer = fgets($frule, 4096)) !== false)
    {
        $value = explode('=',$buffer);
        $key = trim($value[0]);
        $rules[$key]=trim($value[1]);
    }
        
    fclose($frule);
    if(isset($_POST['emergency']) && !empty($_POST['emergency']))
    {
        $frule = fopen($path.RULES_FILE,'r+');
        if($frule===FALSE)
        {
            header('HTTP/1.1 500 Internal Server Error');
            echo "can't open rule file\n";
            exit(1);
        }     
        foreach($rules as $key => &$value)
        {
            if(isset($_POST[$key])&& !empty($_POST[$key]))
            {
                $value = $_POST[$key];
                if (fwrite($frule,"$key=$value\n") === FALSE)
                {
                    header('HTTP/1.1 500 Internal Server Error');
                    echo "can't write rule file\n";
                    exit(1);
                }
            }
        }
        fclose($frule);
    }
    echo json_encode($rules);
}
elseif($action =='rules')
{
    if(isset($_POST['name']) && !empty($_POST['name']))
    {
        $params[':name'] = $_POST['name'];
        $params[':host'] = $_POST['from_host'];
        $params[':contain'] = $_POST['message_contains'];
        $params[':number'] = $_POST['match_number'];
        $params[':time'] = $_POST['time_between'];
        $tmp=NULL;
            $prio = json_decode($_POST['priority']);
        if(!empty($prio))
        {
            $tmp = "{";
            //$prio =  explode(',',$_POST['priority']);
            foreach($prio as $p)
            {
                $tmp.=$priority_link[$p].',';
            }
            $tmp = rtrim($tmp,',');
            $tmp.="}";
        }
        $params[':priority'] = $tmp;
        //mise à jour de la DB
        if(isset($_POST['id']) && !empty($_POST['id']))
        {
            $params[':id'] = $_POST['id'];
            $sql="UPDATE syslog_rules SET rule_name=:name, rule_from_host=:host, rule_message_contain=:contain, rule_match_number=:number,rule_match_time=:time,rule_priority=:priority
	              WHERE rule_id= :id;";
        }
        else
        {
            //ajout de la nouvelle règle.
            $sql="INSERT INTO syslog_rules (rule_name, rule_from_host, rule_message_contain, rule_match_number, rule_match_time,rule_priority,rule_order)
	              VALUES (:name,:host,:contain,:number,:time,:priority,9999) RETURNING rule_id;";
        }
        $query = $dbconnection->prepare($sql);
        foreach($params as $key => $value)
        {
            if(empty($value))
            {
                 $query->bindValue($key, null, PDO::PARAM_NULL);
            }
            else
            {
                $query->bindValue($key, $value); 
            }
        }
        $ret = $query->execute();
		if($ret===false)
		{
            $err = $query->errorInfo();
            throw new Exception($err[2]);
        } 
        if(isset($_POST['id']) && !empty($_POST['id']))
        {
            $_GET['id']=$_POST['id'];
        }
        else
        {
            $row=$query->fetch(PDO::FETCH_OBJ);
            $_GET['id']=$row->rule_id;
        }
    }
    $sql="SELECT rule_id,rule_name,rule_from_host,rule_message_contain,rule_match_number,extract(epoch from rule_last_send)::BIGINT as rule_last_send,array_to_json(rule_priority) as rule_priority,rule_match_time,rule_order
         FROM syslog_rules";
    $params=array();
    if(isset($_GET['id']))
    {
        $sql.=" WHERE rule_id=?";
        $params[]=$_GET['id'];      
    }
    $sql.=" ORDER BY rule_order";
    Trace('GETRULES');
    $query = $dbconnection->prepare($sql);
    $query->execute($params); 
    $arr = array();
    $priority_link_inv = array_flip($priority_link);
    while($row=$query->fetch(PDO::FETCH_OBJ))
    {
        $priotrity = json_decode($row->rule_priority);
        $tmp=array();
        foreach($priotrity as $key => $prio)
        { 
            $tmp[]= $priority_link_inv[$prio];
        }
        $arr[]=array('id'=>$row->rule_id,
                     'name'=>$row->rule_name,
                     'from_host'=>$row->rule_from_host,
                     'message_contains'=>$row->rule_message_contain,
                     'match_number'=>$row->rule_match_number,
                     'last_match'=>$row->rule_last_send,
                     'severity'=>$tmp,
                     'time_between'=>$row->rule_match_time,
                     'order'=>$row->rule_order);
    }
    Trace($arr);
    echo json_encode($arr);
}
elseif($action =='orderRules')
{
    if(isset($_POST['order']) && !empty($_POST['order']))
    {
        $listrule = json_decode($_POST['order'],true);
            //Préparation SQL
            $sql="UPDATE syslog_rules SET rule_order=? WHERE rule_id=?";
            $query = $dbconnection->prepare($sql);
            foreach($listrule as $i=>$id)
            {
                $ret = $query->execute(array($i,$id)); 
		        if($ret===false)
		        {
			        $err = $query->errorInfo();
			        throw new Exception($err[2]);
		        }
            }
            echo json_encode($arr);
    }
}
elseif($action =='deleterules')
{
    if(isset($_POST['id']) && !empty($_POST['id']))
    {
        $listrule = json_decode($_POST['id'],true);
        //Préparation SQL
        $sql="DELETE FROM syslog_rules WHERE rule_id=?";
        $query = $dbconnection->prepare($sql);
            foreach($listrule as $i=>$id)
            {
                $ret = $query->execute(array($id)); 
		        if($ret===false)
		        {
			        $err = $query->errorInfo();
			        throw new Exception($err[2]);
		        }
            }
            echo json_encode(array('statut'=>0));
    }
}
elseif($action =='getHosts')
{
    $sql="SELECT DISTINCT fromhost FROM systemevents";
    Trace('GETHOSTS');
    $query = $dbconnection->prepare($sql);
    $query->execute(); 
    $arr = array();
    while($row=$query->fetch(PDO::FETCH_OBJ))
    {
        $arr[]=$row->fromhost;
    }
    Trace($arr);
    echo json_encode($arr);
}
?>
