<?php
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
require $path.'/common.php';
if(!isset($_GET['DEBUG']))
{
    $_GET['DEBUG']=0;
}

//table de correspondance

$priority_link_inv = array_flip($priority_link);
$facility_link_inv = array_flip($facility_link);

$interval = '1 day';
if(isset($_GET ['hour']) &&!empty($_GET ['hour']))
{
    $interval= $_GET ['hour'].' hour';
}
if(isset($_GET ['day']) &&!empty($_GET ['day']))
{
    $interval= $_GET ['day'].' day';
}
//
//gestion des pages et des limits
//
$limit='';
$page=0;
$params=array('inter'=>$interval);
if(isset($_GET['page']) &&!empty($_GET['page']))
{
    $page= $_GET['page'];
}
if(isset($_GET['size'])&&!empty($_GET['size']))
{
    $size= $_GET['size'];
    if(is_numeric($size) && is_numeric($page))
    {
        $limit='LIMIT '.$size.' OFFSET '.($page*$size);
    }
}
//
//GESTION des filtres
//
$filters='';

//
//Filtres HOST
//
if(isset($_GET['filter_host'])&&!empty($_GET['filter_host']))
{
    $host = urldecode($_GET['filter_host']);
    Trace('FILTER BY HOST '.$host);
    if(preg_match('#^\!.*#',$host))
    {
        $host = preg_replace('#\!#','',$host);
        $filters.=" AND fromhost NOT ILIKE :host";
        $params['host']='%'.$host.'%';
    }
    elseif(preg_match('#^\:.*$#',$host))
    {
        $host = preg_replace('#\:#','',$host);
        $filters.=" AND fromhost = :host";
        $params['host']=$host;
    }
    else
    {
        $filters.=" AND fromhost ILIKE :host";
        $params['host']='%'.$host.'%';
    }

}
//
//Filtres Message
//
if(isset($_GET['filter_message'])&&!empty($_GET['filter_message']))
{
    $msg = urldecode($_GET['filter_message']);
    Trace('FILTER BY MESSAGE '.$msg);
    if(preg_match('#^\!.*#',$msg))
    {
        $host = preg_replace('#\!#','',$msg);
        $filters.=" AND message NOT ILIKE :msg";
    }
    else
    {
        $filters.=" AND message ILIKE :msg";
    }
    $params['msg']='%'.$msg.'%';
}
//
//Filtres receivedat
//
if(isset($_GET['filter_date'])&&!empty($_GET['filter_date']))
{
    $date = urldecode($_GET['filter_date']);
    Trace('FILTER BY DATE '.$date);
    if(preg_match('#^\!.*#',$date))
    {
        $host = preg_replace('#\!#','',$date);
        $filters.=" AND to_char(receivedat,'DD-MM-YYYY HH24:MI:SS') NOT ILIKE :date";
    }
    else
    {
        $filters.=" AND to_char(receivedat,'DD-MM-YYYY HH24:MI:SS') LIKE :date";
    }
    $params['date']='%'.$date.'%';
}
//
//
//Filtres PRIORITY/SEVERITY
//
if(isset($_GET['filter_severity'])&&!empty($_GET['filter_severity']))
{
    $filter_severity = urldecode($_GET['filter_severity']);
    Trace('FILTER BY SEVERITY '.$filter_severity);
	$arr = filterSevFac($filter_severity,$priority_link);
    if(!empty($arr['in']))
    {
        $arrids = implode(',', $arr['in']);
        $filters.=" AND priority IN($arrids)";
    }
    if(!empty($arr['notin']))
    {
        $arrids = implode(',', $arr['notin']);
        $filters.=" AND priority NOT IN($arrids)";
    }
}
//
//Filtres FACILITY
//
if(isset($_GET['filter_facility'])&&!empty($_GET['filter_facility']))
{
    $filter_fac= urldecode($_GET['filter_facility']);
    Trace('FILTER BY FACILITY '.$filter_fac);
    $arr = filterSevFac($filter_fac,$facility_link);
    if(!empty($arr['in']))
    {
        $arrids = implode(',', $arr['in']);
        $filters.=" AND facility IN($arrids)";
    }
    if(!empty($arr['notin']))
    {
        $arrids = implode(',', $arr['notin']);
        $filters.=" AND facility NOT IN($arrids)";
    }
}

$sql="SELECT receivedat,fromhost,priority,facility,message
                                FROM systemevents
                                WHERE receivedat > (NOW() - cast( :inter as interval)) $filters
                                ORDER BY receivedat DESC
                                $limit";
Trace('SQL: '.$sql);
Trace('PARAMS: ');
Trace($params);
$query = $dbconnection->prepare($sql);
$query->execute($params);
$arr = array();
$total =0;
while($row=$query->fetch(PDO::FETCH_OBJ))
{
    $tmp = $priority_link_inv[$row->priority];
    $fac = $facility_link_inv[$row->facility];
    $arr[]=array('date'=>$row->receivedat,'host'=>$row->fromhost,'severity'=>$tmp,'facility'=>$fac,'message'=>$row->message);
    $total++;
}
if(!empty($limit))
{
    $query = $dbconnection->prepare("SELECT count(*) as nbr
                                    FROM systemevents
                                    WHERE receivedat > (NOW() - cast( :inter as interval)) $filters");
    $query->execute($params);
    $row=$query->fetch(PDO::FETCH_OBJ);
    $total = $row->nbr;
}
$json_array['data']=$arr;
$json_array['total_logs']=$total;
echo json_encode($json_array);
function filterSevFac($filters,$linkarr)
{
	if(strstr($filters, '||'))
    {
        $filters = explode('||', $filters);
    }
    else
    {
        $filters = array($filters);
    }
    $array_in=array();
    $array_notin=array();
    foreach($filters as $filter)
    {
        Trace('FILTER FCT FOREACH:'.$filter);
        $flag_not=FALSE;
        if(preg_match('#^\!.*#',$filter))
        {
            $filter = preg_replace('#\!#','',$filter);
            $flag_not=TRUE;
            Trace('FILTER BY FCT FLAG NOT DETECTED');
        }
        foreach($linkarr as $prio => $ind)
        {
            Trace("FILTER BY FCT $filter is $prio");
            if(stripos($prio,$filter) !==FALSE)
            {
                Trace("FILTER FCT $filter is $prio FOUND");
                if($flag_not==TRUE)
                {
                     $array_notin[]=$ind;
                }
                else
                {
                    $array_in[]=$ind;
                }
            }
        }
    }
    Trace('FILTER BY SEVERITY ARRAY IN:');
    Trace($array_notin);
    Trace('FILTER BY SEVERITY ARRAY NOT IN:');
    Trace($array_in);
    return array('in'=>$array_in,'notint'=>$array_in);
}
?>
